#include "../librpc/gen_ndr/ndr_oxidresolver.h"
#ifndef __CLI_IOXIDRESOLVER__
#define __CLI_IOXIDRESOLVER__
struct tevent_req *rpccli_ResolveOxid_send(TALLOC_CTX *mem_ctx,
					   struct tevent_context *ev,
					   struct rpc_pipe_client *cli,
					   uint64_t _pOxid /* [in]  */,
					   uint16_t _cRequestedProtseqs /* [in]  */,
					   uint16_t *_arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
					   struct DUALSTRINGARRAY **_ppdsaOxidBindings /* [out] [ref] */,
					   struct GUID *_pipidRemUnknown /* [out] [ref] */,
					   uint32_t *_pAuthnHint /* [out] [ref] */);
NTSTATUS rpccli_ResolveOxid_recv(struct tevent_req *req,
				 TALLOC_CTX *mem_ctx,
				 WERROR *result);
NTSTATUS rpccli_ResolveOxid(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t pOxid /* [in]  */,
			    uint16_t cRequestedProtseqs /* [in]  */,
			    uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			    struct DUALSTRINGARRAY **ppdsaOxidBindings /* [out] [ref] */,
			    struct GUID *pipidRemUnknown /* [out] [ref] */,
			    uint32_t *pAuthnHint /* [out] [ref] */,
			    WERROR *werror);
struct tevent_req *rpccli_SimplePing_send(TALLOC_CTX *mem_ctx,
					  struct tevent_context *ev,
					  struct rpc_pipe_client *cli,
					  uint64_t *_SetId /* [in] [ref] */);
NTSTATUS rpccli_SimplePing_recv(struct tevent_req *req,
				TALLOC_CTX *mem_ctx,
				WERROR *result);
NTSTATUS rpccli_SimplePing(struct rpc_pipe_client *cli,
			   TALLOC_CTX *mem_ctx,
			   uint64_t *SetId /* [in] [ref] */,
			   WERROR *werror);
struct tevent_req *rpccli_ComplexPing_send(TALLOC_CTX *mem_ctx,
					   struct tevent_context *ev,
					   struct rpc_pipe_client *cli,
					   uint64_t *_SetId /* [in,out] [ref] */,
					   uint16_t _SequenceNum /* [in]  */,
					   uint16_t _cAddToSet /* [in]  */,
					   uint16_t _cDelFromSet /* [in]  */,
					   struct GUID *_AddToSet /* [in] [size_is(cAddToSet)] */,
					   struct GUID *_DelFromSet /* [in] [size_is(cDelFromSet)] */,
					   uint16_t *_PingBackoffFactor /* [out] [ref] */);
NTSTATUS rpccli_ComplexPing_recv(struct tevent_req *req,
				 TALLOC_CTX *mem_ctx,
				 WERROR *result);
NTSTATUS rpccli_ComplexPing(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    uint64_t *SetId /* [in,out] [ref] */,
			    uint16_t SequenceNum /* [in]  */,
			    uint16_t cAddToSet /* [in]  */,
			    uint16_t cDelFromSet /* [in]  */,
			    struct GUID *AddToSet /* [in] [size_is(cAddToSet)] */,
			    struct GUID *DelFromSet /* [in] [size_is(cDelFromSet)] */,
			    uint16_t *PingBackoffFactor /* [out] [ref] */,
			    WERROR *werror);
struct tevent_req *rpccli_ServerAlive_send(TALLOC_CTX *mem_ctx,
					   struct tevent_context *ev,
					   struct rpc_pipe_client *cli);
NTSTATUS rpccli_ServerAlive_recv(struct tevent_req *req,
				 TALLOC_CTX *mem_ctx,
				 WERROR *result);
NTSTATUS rpccli_ServerAlive(struct rpc_pipe_client *cli,
			    TALLOC_CTX *mem_ctx,
			    WERROR *werror);
struct tevent_req *rpccli_ResolveOxid2_send(TALLOC_CTX *mem_ctx,
					    struct tevent_context *ev,
					    struct rpc_pipe_client *cli,
					    uint64_t _pOxid /* [in]  */,
					    uint16_t _cRequestedProtseqs /* [in]  */,
					    uint16_t *_arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
					    struct DUALSTRINGARRAY **_pdsaOxidBindings /* [out] [ref] */,
					    struct GUID *_ipidRemUnknown /* [out] [ref] */,
					    uint32_t *_AuthnHint /* [out] [ref] */,
					    struct COMVERSION *_ComVersion /* [out] [ref] */);
NTSTATUS rpccli_ResolveOxid2_recv(struct tevent_req *req,
				  TALLOC_CTX *mem_ctx,
				  WERROR *result);
NTSTATUS rpccli_ResolveOxid2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     uint64_t pOxid /* [in]  */,
			     uint16_t cRequestedProtseqs /* [in]  */,
			     uint16_t *arRequestedProtseqs /* [in] [size_is(cRequestedProtseqs)] */,
			     struct DUALSTRINGARRAY **pdsaOxidBindings /* [out] [ref] */,
			     struct GUID *ipidRemUnknown /* [out] [ref] */,
			     uint32_t *AuthnHint /* [out] [ref] */,
			     struct COMVERSION *ComVersion /* [out] [ref] */,
			     WERROR *werror);
struct tevent_req *rpccli_ServerAlive2_send(TALLOC_CTX *mem_ctx,
					    struct tevent_context *ev,
					    struct rpc_pipe_client *cli,
					    struct COMINFO *_info /* [out] [ref] */,
					    struct DUALSTRINGARRAY *_dualstring /* [out] [ref] */,
					    uint8_t *_unknown2 /* [out] [ref] */,
					    uint8_t *_unknown3 /* [out] [ref] */,
					    uint8_t *_unknown4 /* [out] [ref] */);
NTSTATUS rpccli_ServerAlive2_recv(struct tevent_req *req,
				  TALLOC_CTX *mem_ctx,
				  WERROR *result);
NTSTATUS rpccli_ServerAlive2(struct rpc_pipe_client *cli,
			     TALLOC_CTX *mem_ctx,
			     struct COMINFO *info /* [out] [ref] */,
			     struct DUALSTRINGARRAY *dualstring /* [out] [ref] */,
			     uint8_t *unknown2 /* [out] [ref] */,
			     uint8_t *unknown3 /* [out] [ref] */,
			     uint8_t *unknown4 /* [out] [ref] */,
			     WERROR *werror);
#endif /* __CLI_IOXIDRESOLVER__ */
