/*
 * Unix SMB/CIFS implementation.
 * server auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/srv_drsuapi.h"

static bool api_drsuapi_DsBind(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsBind *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSBIND];

	r = talloc(talloc_tos(), struct drsuapi_DsBind);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsBind, r);
	}

	ZERO_STRUCT(r->out);
	r->out.bind_info = r->in.bind_info;
	r->out.bind_handle = talloc_zero(r, struct policy_handle);
	if (r->out.bind_handle == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsBind(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsBind, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsUnbind(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsUnbind *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSUNBIND];

	r = talloc(talloc_tos(), struct drsuapi_DsUnbind);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsUnbind, r);
	}

	ZERO_STRUCT(r->out);
	r->out.bind_handle = r->in.bind_handle;
	r->out.result = _drsuapi_DsUnbind(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsUnbind, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsReplicaSync(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsReplicaSync *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSREPLICASYNC];

	r = talloc(talloc_tos(), struct drsuapi_DsReplicaSync);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsReplicaSync, r);
	}

	r->out.result = _drsuapi_DsReplicaSync(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsReplicaSync, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsGetNCChanges(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsGetNCChanges *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSGETNCCHANGES];

	r = talloc(talloc_tos(), struct drsuapi_DsGetNCChanges);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsGetNCChanges, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.ctr = talloc_zero(r, union drsuapi_DsGetNCChangesCtr);
	if (r->out.ctr == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsGetNCChanges(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsGetNCChanges, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsReplicaUpdateRefs(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsReplicaUpdateRefs *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSREPLICAUPDATEREFS];

	r = talloc(talloc_tos(), struct drsuapi_DsReplicaUpdateRefs);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsReplicaUpdateRefs, r);
	}

	r->out.result = _drsuapi_DsReplicaUpdateRefs(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsReplicaUpdateRefs, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsReplicaAdd(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsReplicaAdd *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSREPLICAADD];

	r = talloc(talloc_tos(), struct drsuapi_DsReplicaAdd);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsReplicaAdd, r);
	}

	r->out.result = _drsuapi_DsReplicaAdd(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsReplicaAdd, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsReplicaDel(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsReplicaDel *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSREPLICADEL];

	r = talloc(talloc_tos(), struct drsuapi_DsReplicaDel);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsReplicaDel, r);
	}

	r->out.result = _drsuapi_DsReplicaDel(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsReplicaDel, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsReplicaMod(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsReplicaMod *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSREPLICAMOD];

	r = talloc(talloc_tos(), struct drsuapi_DsReplicaMod);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsReplicaMod, r);
	}

	r->out.result = _drsuapi_DsReplicaMod(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsReplicaMod, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_DRSUAPI_VERIFY_NAMES(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct DRSUAPI_VERIFY_NAMES *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_VERIFY_NAMES];

	r = talloc(talloc_tos(), struct DRSUAPI_VERIFY_NAMES);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(DRSUAPI_VERIFY_NAMES, r);
	}

	r->out.result = _DRSUAPI_VERIFY_NAMES(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(DRSUAPI_VERIFY_NAMES, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsGetMemberships(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsGetMemberships *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSGETMEMBERSHIPS];

	r = talloc(talloc_tos(), struct drsuapi_DsGetMemberships);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsGetMemberships, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.ctr = talloc_zero(r, union drsuapi_DsGetMembershipsCtr);
	if (r->out.ctr == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsGetMemberships(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsGetMemberships, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_DRSUAPI_INTER_DOMAIN_MOVE(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct DRSUAPI_INTER_DOMAIN_MOVE *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_INTER_DOMAIN_MOVE];

	r = talloc(talloc_tos(), struct DRSUAPI_INTER_DOMAIN_MOVE);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(DRSUAPI_INTER_DOMAIN_MOVE, r);
	}

	r->out.result = _DRSUAPI_INTER_DOMAIN_MOVE(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(DRSUAPI_INTER_DOMAIN_MOVE, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsGetNT4ChangeLog(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsGetNT4ChangeLog *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSGETNT4CHANGELOG];

	r = talloc(talloc_tos(), struct drsuapi_DsGetNT4ChangeLog);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsGetNT4ChangeLog, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, uint32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.info = talloc_zero(r, union drsuapi_DsGetNT4ChangeLogInfo);
	if (r->out.info == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsGetNT4ChangeLog(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsGetNT4ChangeLog, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsCrackNames(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsCrackNames *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSCRACKNAMES];

	r = talloc(talloc_tos(), struct drsuapi_DsCrackNames);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsCrackNames, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.ctr = talloc_zero(r, union drsuapi_DsNameCtr);
	if (r->out.ctr == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsCrackNames(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsCrackNames, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsWriteAccountSpn(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsWriteAccountSpn *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSWRITEACCOUNTSPN];

	r = talloc(talloc_tos(), struct drsuapi_DsWriteAccountSpn);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsWriteAccountSpn, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.res = talloc_zero(r, union drsuapi_DsWriteAccountSpnResult);
	if (r->out.res == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsWriteAccountSpn(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsWriteAccountSpn, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsRemoveDSServer(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsRemoveDSServer *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSREMOVEDSSERVER];

	r = talloc(talloc_tos(), struct drsuapi_DsRemoveDSServer);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsRemoveDSServer, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.res = talloc_zero(r, union drsuapi_DsRemoveDSServerResult);
	if (r->out.res == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsRemoveDSServer(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsRemoveDSServer, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_DRSUAPI_REMOVE_DS_DOMAIN(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct DRSUAPI_REMOVE_DS_DOMAIN *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_REMOVE_DS_DOMAIN];

	r = talloc(talloc_tos(), struct DRSUAPI_REMOVE_DS_DOMAIN);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(DRSUAPI_REMOVE_DS_DOMAIN, r);
	}

	r->out.result = _DRSUAPI_REMOVE_DS_DOMAIN(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(DRSUAPI_REMOVE_DS_DOMAIN, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsGetDomainControllerInfo(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsGetDomainControllerInfo *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSGETDOMAINCONTROLLERINFO];

	r = talloc(talloc_tos(), struct drsuapi_DsGetDomainControllerInfo);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsGetDomainControllerInfo, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.ctr = talloc_zero(r, union drsuapi_DsGetDCInfoCtr);
	if (r->out.ctr == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsGetDomainControllerInfo(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsGetDomainControllerInfo, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsAddEntry(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsAddEntry *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSADDENTRY];

	r = talloc(talloc_tos(), struct drsuapi_DsAddEntry);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsAddEntry, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.ctr = talloc_zero(r, union drsuapi_DsAddEntryCtr);
	if (r->out.ctr == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsAddEntry(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsAddEntry, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsExecuteKCC(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsExecuteKCC *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSEXECUTEKCC];

	r = talloc(talloc_tos(), struct drsuapi_DsExecuteKCC);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsExecuteKCC, r);
	}

	r->out.result = _drsuapi_DsExecuteKCC(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsExecuteKCC, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsReplicaGetInfo(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsReplicaGetInfo *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSREPLICAGETINFO];

	r = talloc(talloc_tos(), struct drsuapi_DsReplicaGetInfo);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsReplicaGetInfo, r);
	}

	ZERO_STRUCT(r->out);
	r->out.info_type = talloc_zero(r, enum drsuapi_DsReplicaInfoType);
	if (r->out.info_type == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.info = talloc_zero(r, union drsuapi_DsReplicaInfo);
	if (r->out.info == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsReplicaGetInfo(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsReplicaGetInfo, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_DRSUAPI_ADD_SID_HISTORY(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct DRSUAPI_ADD_SID_HISTORY *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_ADD_SID_HISTORY];

	r = talloc(talloc_tos(), struct DRSUAPI_ADD_SID_HISTORY);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(DRSUAPI_ADD_SID_HISTORY, r);
	}

	r->out.result = _DRSUAPI_ADD_SID_HISTORY(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(DRSUAPI_ADD_SID_HISTORY, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_DsGetMemberships2(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_DsGetMemberships2 *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_DSGETMEMBERSHIPS2];

	r = talloc(talloc_tos(), struct drsuapi_DsGetMemberships2);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_DsGetMemberships2, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.ctr = talloc_zero(r, union drsuapi_DsGetMemberships2Ctr);
	if (r->out.ctr == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_DsGetMemberships2(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_DsGetMemberships2, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_DRSUAPI_REPLICA_VERIFY_OBJECTS(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct DRSUAPI_REPLICA_VERIFY_OBJECTS *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_REPLICA_VERIFY_OBJECTS];

	r = talloc(talloc_tos(), struct DRSUAPI_REPLICA_VERIFY_OBJECTS);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(DRSUAPI_REPLICA_VERIFY_OBJECTS, r);
	}

	r->out.result = _DRSUAPI_REPLICA_VERIFY_OBJECTS(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(DRSUAPI_REPLICA_VERIFY_OBJECTS, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_DRSUAPI_GET_OBJECT_EXISTENCE(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct DRSUAPI_GET_OBJECT_EXISTENCE *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_GET_OBJECT_EXISTENCE];

	r = talloc(talloc_tos(), struct DRSUAPI_GET_OBJECT_EXISTENCE);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(DRSUAPI_GET_OBJECT_EXISTENCE, r);
	}

	r->out.result = _DRSUAPI_GET_OBJECT_EXISTENCE(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(DRSUAPI_GET_OBJECT_EXISTENCE, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_drsuapi_QuerySitesByCost(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct drsuapi_QuerySitesByCost *r;

	call = &ndr_table_drsuapi.calls[NDR_DRSUAPI_QUERYSITESBYCOST];

	r = talloc(talloc_tos(), struct drsuapi_QuerySitesByCost);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(drsuapi_QuerySitesByCost, r);
	}

	ZERO_STRUCT(r->out);
	r->out.level_out = talloc_zero(r, int32_t);
	if (r->out.level_out == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.ctr = talloc_zero(r, union drsuapi_QuerySitesByCostCtr);
	if (r->out.ctr == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _drsuapi_QuerySitesByCost(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(drsuapi_QuerySitesByCost, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}


/* Tables */
static struct api_struct api_drsuapi_cmds[] = 
{
	{"DRSUAPI_DSBIND", NDR_DRSUAPI_DSBIND, api_drsuapi_DsBind},
	{"DRSUAPI_DSUNBIND", NDR_DRSUAPI_DSUNBIND, api_drsuapi_DsUnbind},
	{"DRSUAPI_DSREPLICASYNC", NDR_DRSUAPI_DSREPLICASYNC, api_drsuapi_DsReplicaSync},
	{"DRSUAPI_DSGETNCCHANGES", NDR_DRSUAPI_DSGETNCCHANGES, api_drsuapi_DsGetNCChanges},
	{"DRSUAPI_DSREPLICAUPDATEREFS", NDR_DRSUAPI_DSREPLICAUPDATEREFS, api_drsuapi_DsReplicaUpdateRefs},
	{"DRSUAPI_DSREPLICAADD", NDR_DRSUAPI_DSREPLICAADD, api_drsuapi_DsReplicaAdd},
	{"DRSUAPI_DSREPLICADEL", NDR_DRSUAPI_DSREPLICADEL, api_drsuapi_DsReplicaDel},
	{"DRSUAPI_DSREPLICAMOD", NDR_DRSUAPI_DSREPLICAMOD, api_drsuapi_DsReplicaMod},
	{"DRSUAPI_VERIFY_NAMES", NDR_DRSUAPI_VERIFY_NAMES, api_DRSUAPI_VERIFY_NAMES},
	{"DRSUAPI_DSGETMEMBERSHIPS", NDR_DRSUAPI_DSGETMEMBERSHIPS, api_drsuapi_DsGetMemberships},
	{"DRSUAPI_INTER_DOMAIN_MOVE", NDR_DRSUAPI_INTER_DOMAIN_MOVE, api_DRSUAPI_INTER_DOMAIN_MOVE},
	{"DRSUAPI_DSGETNT4CHANGELOG", NDR_DRSUAPI_DSGETNT4CHANGELOG, api_drsuapi_DsGetNT4ChangeLog},
	{"DRSUAPI_DSCRACKNAMES", NDR_DRSUAPI_DSCRACKNAMES, api_drsuapi_DsCrackNames},
	{"DRSUAPI_DSWRITEACCOUNTSPN", NDR_DRSUAPI_DSWRITEACCOUNTSPN, api_drsuapi_DsWriteAccountSpn},
	{"DRSUAPI_DSREMOVEDSSERVER", NDR_DRSUAPI_DSREMOVEDSSERVER, api_drsuapi_DsRemoveDSServer},
	{"DRSUAPI_REMOVE_DS_DOMAIN", NDR_DRSUAPI_REMOVE_DS_DOMAIN, api_DRSUAPI_REMOVE_DS_DOMAIN},
	{"DRSUAPI_DSGETDOMAINCONTROLLERINFO", NDR_DRSUAPI_DSGETDOMAINCONTROLLERINFO, api_drsuapi_DsGetDomainControllerInfo},
	{"DRSUAPI_DSADDENTRY", NDR_DRSUAPI_DSADDENTRY, api_drsuapi_DsAddEntry},
	{"DRSUAPI_DSEXECUTEKCC", NDR_DRSUAPI_DSEXECUTEKCC, api_drsuapi_DsExecuteKCC},
	{"DRSUAPI_DSREPLICAGETINFO", NDR_DRSUAPI_DSREPLICAGETINFO, api_drsuapi_DsReplicaGetInfo},
	{"DRSUAPI_ADD_SID_HISTORY", NDR_DRSUAPI_ADD_SID_HISTORY, api_DRSUAPI_ADD_SID_HISTORY},
	{"DRSUAPI_DSGETMEMBERSHIPS2", NDR_DRSUAPI_DSGETMEMBERSHIPS2, api_drsuapi_DsGetMemberships2},
	{"DRSUAPI_REPLICA_VERIFY_OBJECTS", NDR_DRSUAPI_REPLICA_VERIFY_OBJECTS, api_DRSUAPI_REPLICA_VERIFY_OBJECTS},
	{"DRSUAPI_GET_OBJECT_EXISTENCE", NDR_DRSUAPI_GET_OBJECT_EXISTENCE, api_DRSUAPI_GET_OBJECT_EXISTENCE},
	{"DRSUAPI_QUERYSITESBYCOST", NDR_DRSUAPI_QUERYSITESBYCOST, api_drsuapi_QuerySitesByCost},
};

void drsuapi_get_pipe_fns(struct api_struct **fns, int *n_fns)
{
	*fns = api_drsuapi_cmds;
	*n_fns = sizeof(api_drsuapi_cmds) / sizeof(struct api_struct);
}

NTSTATUS rpc_drsuapi_dispatch(struct rpc_pipe_client *cli, TALLOC_CTX *mem_ctx, const struct ndr_interface_table *table, uint32_t opnum, void *_r)
{
	if (cli->pipes_struct == NULL) {
		return NT_STATUS_INVALID_PARAMETER;
	}

	switch (opnum)
	{
		case NDR_DRSUAPI_DSBIND: {
			struct drsuapi_DsBind *r = (struct drsuapi_DsBind *)_r;
			ZERO_STRUCT(r->out);
			r->out.bind_info = r->in.bind_info;
			r->out.bind_handle = talloc_zero(mem_ctx, struct policy_handle);
			if (r->out.bind_handle == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsBind(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSUNBIND: {
			struct drsuapi_DsUnbind *r = (struct drsuapi_DsUnbind *)_r;
			ZERO_STRUCT(r->out);
			r->out.bind_handle = r->in.bind_handle;
			r->out.result = _drsuapi_DsUnbind(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSREPLICASYNC: {
			struct drsuapi_DsReplicaSync *r = (struct drsuapi_DsReplicaSync *)_r;
			r->out.result = _drsuapi_DsReplicaSync(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSGETNCCHANGES: {
			struct drsuapi_DsGetNCChanges *r = (struct drsuapi_DsGetNCChanges *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.ctr = talloc_zero(mem_ctx, union drsuapi_DsGetNCChangesCtr);
			if (r->out.ctr == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsGetNCChanges(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSREPLICAUPDATEREFS: {
			struct drsuapi_DsReplicaUpdateRefs *r = (struct drsuapi_DsReplicaUpdateRefs *)_r;
			r->out.result = _drsuapi_DsReplicaUpdateRefs(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSREPLICAADD: {
			struct drsuapi_DsReplicaAdd *r = (struct drsuapi_DsReplicaAdd *)_r;
			r->out.result = _drsuapi_DsReplicaAdd(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSREPLICADEL: {
			struct drsuapi_DsReplicaDel *r = (struct drsuapi_DsReplicaDel *)_r;
			r->out.result = _drsuapi_DsReplicaDel(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSREPLICAMOD: {
			struct drsuapi_DsReplicaMod *r = (struct drsuapi_DsReplicaMod *)_r;
			r->out.result = _drsuapi_DsReplicaMod(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_VERIFY_NAMES: {
			struct DRSUAPI_VERIFY_NAMES *r = (struct DRSUAPI_VERIFY_NAMES *)_r;
			r->out.result = _DRSUAPI_VERIFY_NAMES(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSGETMEMBERSHIPS: {
			struct drsuapi_DsGetMemberships *r = (struct drsuapi_DsGetMemberships *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.ctr = talloc_zero(mem_ctx, union drsuapi_DsGetMembershipsCtr);
			if (r->out.ctr == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsGetMemberships(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_INTER_DOMAIN_MOVE: {
			struct DRSUAPI_INTER_DOMAIN_MOVE *r = (struct DRSUAPI_INTER_DOMAIN_MOVE *)_r;
			r->out.result = _DRSUAPI_INTER_DOMAIN_MOVE(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSGETNT4CHANGELOG: {
			struct drsuapi_DsGetNT4ChangeLog *r = (struct drsuapi_DsGetNT4ChangeLog *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, uint32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.info = talloc_zero(mem_ctx, union drsuapi_DsGetNT4ChangeLogInfo);
			if (r->out.info == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsGetNT4ChangeLog(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSCRACKNAMES: {
			struct drsuapi_DsCrackNames *r = (struct drsuapi_DsCrackNames *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.ctr = talloc_zero(mem_ctx, union drsuapi_DsNameCtr);
			if (r->out.ctr == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsCrackNames(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSWRITEACCOUNTSPN: {
			struct drsuapi_DsWriteAccountSpn *r = (struct drsuapi_DsWriteAccountSpn *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.res = talloc_zero(mem_ctx, union drsuapi_DsWriteAccountSpnResult);
			if (r->out.res == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsWriteAccountSpn(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSREMOVEDSSERVER: {
			struct drsuapi_DsRemoveDSServer *r = (struct drsuapi_DsRemoveDSServer *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.res = talloc_zero(mem_ctx, union drsuapi_DsRemoveDSServerResult);
			if (r->out.res == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsRemoveDSServer(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_REMOVE_DS_DOMAIN: {
			struct DRSUAPI_REMOVE_DS_DOMAIN *r = (struct DRSUAPI_REMOVE_DS_DOMAIN *)_r;
			r->out.result = _DRSUAPI_REMOVE_DS_DOMAIN(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSGETDOMAINCONTROLLERINFO: {
			struct drsuapi_DsGetDomainControllerInfo *r = (struct drsuapi_DsGetDomainControllerInfo *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.ctr = talloc_zero(mem_ctx, union drsuapi_DsGetDCInfoCtr);
			if (r->out.ctr == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsGetDomainControllerInfo(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSADDENTRY: {
			struct drsuapi_DsAddEntry *r = (struct drsuapi_DsAddEntry *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.ctr = talloc_zero(mem_ctx, union drsuapi_DsAddEntryCtr);
			if (r->out.ctr == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsAddEntry(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSEXECUTEKCC: {
			struct drsuapi_DsExecuteKCC *r = (struct drsuapi_DsExecuteKCC *)_r;
			r->out.result = _drsuapi_DsExecuteKCC(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSREPLICAGETINFO: {
			struct drsuapi_DsReplicaGetInfo *r = (struct drsuapi_DsReplicaGetInfo *)_r;
			ZERO_STRUCT(r->out);
			r->out.info_type = talloc_zero(mem_ctx, enum drsuapi_DsReplicaInfoType);
			if (r->out.info_type == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.info = talloc_zero(mem_ctx, union drsuapi_DsReplicaInfo);
			if (r->out.info == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsReplicaGetInfo(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_ADD_SID_HISTORY: {
			struct DRSUAPI_ADD_SID_HISTORY *r = (struct DRSUAPI_ADD_SID_HISTORY *)_r;
			r->out.result = _DRSUAPI_ADD_SID_HISTORY(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_DSGETMEMBERSHIPS2: {
			struct drsuapi_DsGetMemberships2 *r = (struct drsuapi_DsGetMemberships2 *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.ctr = talloc_zero(mem_ctx, union drsuapi_DsGetMemberships2Ctr);
			if (r->out.ctr == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_DsGetMemberships2(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_REPLICA_VERIFY_OBJECTS: {
			struct DRSUAPI_REPLICA_VERIFY_OBJECTS *r = (struct DRSUAPI_REPLICA_VERIFY_OBJECTS *)_r;
			r->out.result = _DRSUAPI_REPLICA_VERIFY_OBJECTS(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_GET_OBJECT_EXISTENCE: {
			struct DRSUAPI_GET_OBJECT_EXISTENCE *r = (struct DRSUAPI_GET_OBJECT_EXISTENCE *)_r;
			r->out.result = _DRSUAPI_GET_OBJECT_EXISTENCE(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_DRSUAPI_QUERYSITESBYCOST: {
			struct drsuapi_QuerySitesByCost *r = (struct drsuapi_QuerySitesByCost *)_r;
			ZERO_STRUCT(r->out);
			r->out.level_out = talloc_zero(mem_ctx, int32_t);
			if (r->out.level_out == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.ctr = talloc_zero(mem_ctx, union drsuapi_QuerySitesByCostCtr);
			if (r->out.ctr == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _drsuapi_QuerySitesByCost(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		default:
			return NT_STATUS_NOT_IMPLEMENTED;
	}
}

NTSTATUS rpc_drsuapi_init(void)
{
	return rpc_srv_register(SMB_RPC_INTERFACE_VERSION, "drsuapi", "drsuapi", &ndr_table_drsuapi, api_drsuapi_cmds, sizeof(api_drsuapi_cmds) / sizeof(struct api_struct));
}
