/*
 * Unix SMB/CIFS implementation.
 * server auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/srv_mgmt.h"

static bool api_mgmt_inq_if_ids(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct mgmt_inq_if_ids *r;

	call = &ndr_table_mgmt.calls[NDR_MGMT_INQ_IF_IDS];

	r = talloc(talloc_tos(), struct mgmt_inq_if_ids);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_inq_if_ids, r);
	}

	ZERO_STRUCT(r->out);
	r->out.if_id_vector = talloc_zero(r, struct rpc_if_id_vector_t *);
	if (r->out.if_id_vector == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _mgmt_inq_if_ids(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_inq_if_ids, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_mgmt_inq_stats(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct mgmt_inq_stats *r;

	call = &ndr_table_mgmt.calls[NDR_MGMT_INQ_STATS];

	r = talloc(talloc_tos(), struct mgmt_inq_stats);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_inq_stats, r);
	}

	ZERO_STRUCT(r->out);
	r->out.statistics = talloc_zero(r, struct mgmt_statistics);
	if (r->out.statistics == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _mgmt_inq_stats(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_inq_stats, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_mgmt_is_server_listening(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct mgmt_is_server_listening *r;

	call = &ndr_table_mgmt.calls[NDR_MGMT_IS_SERVER_LISTENING];

	r = talloc(talloc_tos(), struct mgmt_is_server_listening);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_is_server_listening, r);
	}

	ZERO_STRUCT(r->out);
	r->out.status = talloc_zero(r, uint32_t);
	if (r->out.status == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _mgmt_is_server_listening(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_is_server_listening, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_mgmt_stop_server_listening(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct mgmt_stop_server_listening *r;

	call = &ndr_table_mgmt.calls[NDR_MGMT_STOP_SERVER_LISTENING];

	r = talloc(talloc_tos(), struct mgmt_stop_server_listening);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_stop_server_listening, r);
	}

	r->out.result = _mgmt_stop_server_listening(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_stop_server_listening, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_mgmt_inq_princ_name(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct mgmt_inq_princ_name *r;

	call = &ndr_table_mgmt.calls[NDR_MGMT_INQ_PRINC_NAME];

	r = talloc(talloc_tos(), struct mgmt_inq_princ_name);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(mgmt_inq_princ_name, r);
	}

	ZERO_STRUCT(r->out);
	#error No size known for array `princ_name'
	if (r->out.princ_name == NULL) {
		talloc_free(r);
		return false;
	}

	r->out.result = _mgmt_inq_princ_name(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(mgmt_inq_princ_name, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}


/* Tables */
static struct api_struct api_mgmt_cmds[] = 
{
	{"MGMT_INQ_IF_IDS", NDR_MGMT_INQ_IF_IDS, api_mgmt_inq_if_ids},
	{"MGMT_INQ_STATS", NDR_MGMT_INQ_STATS, api_mgmt_inq_stats},
	{"MGMT_IS_SERVER_LISTENING", NDR_MGMT_IS_SERVER_LISTENING, api_mgmt_is_server_listening},
	{"MGMT_STOP_SERVER_LISTENING", NDR_MGMT_STOP_SERVER_LISTENING, api_mgmt_stop_server_listening},
	{"MGMT_INQ_PRINC_NAME", NDR_MGMT_INQ_PRINC_NAME, api_mgmt_inq_princ_name},
};

void mgmt_get_pipe_fns(struct api_struct **fns, int *n_fns)
{
	*fns = api_mgmt_cmds;
	*n_fns = sizeof(api_mgmt_cmds) / sizeof(struct api_struct);
}

NTSTATUS rpc_mgmt_dispatch(struct rpc_pipe_client *cli, TALLOC_CTX *mem_ctx, const struct ndr_interface_table *table, uint32_t opnum, void *_r)
{
	if (cli->pipes_struct == NULL) {
		return NT_STATUS_INVALID_PARAMETER;
	}

	switch (opnum)
	{
		case NDR_MGMT_INQ_IF_IDS: {
			struct mgmt_inq_if_ids *r = (struct mgmt_inq_if_ids *)_r;
			ZERO_STRUCT(r->out);
			r->out.if_id_vector = talloc_zero(mem_ctx, struct rpc_if_id_vector_t *);
			if (r->out.if_id_vector == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _mgmt_inq_if_ids(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_MGMT_INQ_STATS: {
			struct mgmt_inq_stats *r = (struct mgmt_inq_stats *)_r;
			ZERO_STRUCT(r->out);
			r->out.statistics = talloc_zero(mem_ctx, struct mgmt_statistics);
			if (r->out.statistics == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _mgmt_inq_stats(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_MGMT_IS_SERVER_LISTENING: {
			struct mgmt_is_server_listening *r = (struct mgmt_is_server_listening *)_r;
			ZERO_STRUCT(r->out);
			r->out.status = talloc_zero(mem_ctx, uint32_t);
			if (r->out.status == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _mgmt_is_server_listening(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_MGMT_STOP_SERVER_LISTENING: {
			struct mgmt_stop_server_listening *r = (struct mgmt_stop_server_listening *)_r;
			r->out.result = _mgmt_stop_server_listening(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_MGMT_INQ_PRINC_NAME: {
			struct mgmt_inq_princ_name *r = (struct mgmt_inq_princ_name *)_r;
			ZERO_STRUCT(r->out);
			#error No size known for array `princ_name'
			if (r->out.princ_name == NULL) {
			return NT_STATUS_NO_MEMORY;
			}

			r->out.result = _mgmt_inq_princ_name(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		default:
			return NT_STATUS_NOT_IMPLEMENTED;
	}
}

NTSTATUS rpc_mgmt_init(void)
{
	return rpc_srv_register(SMB_RPC_INTERFACE_VERSION, "mgmt", "mgmt", &ndr_table_mgmt, api_mgmt_cmds, sizeof(api_mgmt_cmds) / sizeof(struct api_struct));
}
