/*
 * Unix SMB/CIFS implementation.
 * server auto-generated by pidl. DO NOT MODIFY!
 */

#include "includes.h"
#include "../librpc/gen_ndr/srv_w32time.h"

static bool api_w32time_SyncTime(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct w32time_SyncTime *r;

	call = &ndr_table_w32time.calls[NDR_W32TIME_SYNCTIME];

	r = talloc(talloc_tos(), struct w32time_SyncTime);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(w32time_SyncTime, r);
	}

	r->out.result = _w32time_SyncTime(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(w32time_SyncTime, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_w32time_GetNetLogonServiceBits(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct w32time_GetNetLogonServiceBits *r;

	call = &ndr_table_w32time.calls[NDR_W32TIME_GETNETLOGONSERVICEBITS];

	r = talloc(talloc_tos(), struct w32time_GetNetLogonServiceBits);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(w32time_GetNetLogonServiceBits, r);
	}

	r->out.result = _w32time_GetNetLogonServiceBits(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(w32time_GetNetLogonServiceBits, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}

static bool api_w32time_QueryProviderStatus(pipes_struct *p)
{
	const struct ndr_interface_call *call;
	struct ndr_pull *pull;
	struct ndr_push *push;
	enum ndr_err_code ndr_err;
	DATA_BLOB blob;
	struct w32time_QueryProviderStatus *r;

	call = &ndr_table_w32time.calls[NDR_W32TIME_QUERYPROVIDERSTATUS];

	r = talloc(talloc_tos(), struct w32time_QueryProviderStatus);
	if (r == NULL) {
		return false;
	}

	if (!prs_data_blob(&p->in_data.data, &blob, r)) {
		talloc_free(r);
		return false;
	}

	pull = ndr_pull_init_blob(&blob, r, NULL);
	if (pull == NULL) {
		talloc_free(r);
		return false;
	}

	pull->flags |= LIBNDR_FLAG_REF_ALLOC;
	ndr_err = call->ndr_pull(pull, NDR_IN, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_IN_DEBUG(w32time_QueryProviderStatus, r);
	}

	r->out.result = _w32time_QueryProviderStatus(p, r);

	if (p->rng_fault_state) {
		talloc_free(r);
		/* Return true here, srv_pipe_hnd.c will take care */
		return true;
	}

	if (DEBUGLEVEL >= 10) {
		NDR_PRINT_OUT_DEBUG(w32time_QueryProviderStatus, r);
	}

	push = ndr_push_init_ctx(r, NULL);
	if (push == NULL) {
		talloc_free(r);
		return false;
	}

	ndr_err = call->ndr_push(push, NDR_OUT, r);
	if (!NDR_ERR_CODE_IS_SUCCESS(ndr_err)) {
		talloc_free(r);
		return false;
	}

	blob = ndr_push_blob(push);
	if (!prs_copy_data_in(&p->out_data.rdata, (const char *)blob.data, (uint32_t)blob.length)) {
		talloc_free(r);
		return false;
	}

	talloc_free(r);

	return true;
}


/* Tables */
static struct api_struct api_w32time_cmds[] = 
{
	{"W32TIME_SYNCTIME", NDR_W32TIME_SYNCTIME, api_w32time_SyncTime},
	{"W32TIME_GETNETLOGONSERVICEBITS", NDR_W32TIME_GETNETLOGONSERVICEBITS, api_w32time_GetNetLogonServiceBits},
	{"W32TIME_QUERYPROVIDERSTATUS", NDR_W32TIME_QUERYPROVIDERSTATUS, api_w32time_QueryProviderStatus},
};

void w32time_get_pipe_fns(struct api_struct **fns, int *n_fns)
{
	*fns = api_w32time_cmds;
	*n_fns = sizeof(api_w32time_cmds) / sizeof(struct api_struct);
}

NTSTATUS rpc_w32time_dispatch(struct rpc_pipe_client *cli, TALLOC_CTX *mem_ctx, const struct ndr_interface_table *table, uint32_t opnum, void *_r)
{
	if (cli->pipes_struct == NULL) {
		return NT_STATUS_INVALID_PARAMETER;
	}

	switch (opnum)
	{
		case NDR_W32TIME_SYNCTIME: {
			struct w32time_SyncTime *r = (struct w32time_SyncTime *)_r;
			r->out.result = _w32time_SyncTime(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_W32TIME_GETNETLOGONSERVICEBITS: {
			struct w32time_GetNetLogonServiceBits *r = (struct w32time_GetNetLogonServiceBits *)_r;
			r->out.result = _w32time_GetNetLogonServiceBits(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		case NDR_W32TIME_QUERYPROVIDERSTATUS: {
			struct w32time_QueryProviderStatus *r = (struct w32time_QueryProviderStatus *)_r;
			r->out.result = _w32time_QueryProviderStatus(cli->pipes_struct, r);
			return NT_STATUS_OK;
		}

		default:
			return NT_STATUS_NOT_IMPLEMENTED;
	}
}

NTSTATUS rpc_w32time_init(void)
{
	return rpc_srv_register(SMB_RPC_INTERFACE_VERSION, "w32time", "w32time", &ndr_table_w32time, api_w32time_cmds, sizeof(api_w32time_cmds) / sizeof(struct api_struct));
}
